/* file name  : datastruct/clpgui/Domains3D.java
 * authors    : Guillaume Arnaud
 * created    : ven 09 avr 2004 16:05:55 CEST
 * copyright  : 
 *
 * modifications:
 *
 */

package datastruct.clpgui;

/** 
 * 
 * 
 * @author Guillaume Arnaud
 * @version 1.0
 */
public class Domains3D {
    int maxSize=0;
    int time=0;
    int timeMax=10000;
    String info="";
    Domains2D[] domains2D=new Domains2D[timeMax];
    SearchTree[] executedGoals=new SearchTree[timeMax];
    SearchTree current,root;
    private boolean backtrackTrace=false;
    
    public Domains3D(){
    }

    public void setBacktrackTrace(boolean b){backtrackTrace=b;}

    public void backto(SearchTree st){
        if(!backtrackTrace){
            while(time>1 && executedGoals[--time]!=st) {executedGoals[time]=null;}
          //  time++;
        }
    }
    
    public void setMaxSize(int maxSize) {
        this.maxSize=maxSize;
    }
    public int getMaxSize(){return maxSize;}
    
    public void setTime(int time) {this.time=time;}
    public void incTime(){this.time++;}
    public int getTime(){return time;}

    public void setInfo(String info) {this.info=info;}
    public String getInfo(){return info;}
  
    public void setExecutedGoals(SearchTree[] executedGoals) {this.executedGoals=executedGoals;}
    public SearchTree[] getExecutedGoals(){return executedGoals;}
    public void addExecutedGoals(SearchTree searchTree) {        
        executedGoals[time]=searchTree;         
    }
    public void removeLastExecutedGoals(){
        executedGoals[time]=null;
    }
       
    
    public void setCurrent(SearchTree current) {this.current=current;}
    public SearchTree getCurrent(){return current;}

    public void setRoot(SearchTree root) {this.root=root;}
    public SearchTree getRoot(){return root;}

    public boolean ancestor(SearchTree t) {
	SearchTree p=current;
	while (p!=root) {
	    if (p==t) return true;
	    else p=p.father;
	}
	return (t==root);
    }

    public void addDomains2D(Domains2D domains2D){
        try{
        this.domains2D[time]=(Domains2D)domains2D.clone();}
        catch(Exception e){System.out.println("clone proble");}
    }
    public void removeDomains2D(){
        domains2D[time]=null;
    }
    public Domains2D getDomains2D(int t){
        return this.domains2D[t];
    }

}
