/* file name  : parser/MetaPropagationSolverInterface.java
 * authors    : Guillaume Arnaud
 * created    : mer 31 mar 2004 16:28:41 CEST
 * copyright  : 
 *
 * modifications:
 *
 */

package parser.propagation;

import  request.PropagationRequest;
/** 
 * Interface for solver using meta propagation.
 * 
 * @author Guillaume Arnaud
 * @version 1.0
 */
public interface MetaPropagationSolverInterface {
    public  void addMetaPropagationListener(MetaPropagationListener l, PropagationRequest pr);
    public  void removeMetaPropagationListener(MetaPropagationListener l);
    public boolean hasMetaPropagationListener();
     public void notifyMetaPropagationListener(MetaPropagationEvent ev);
}
