/* file name  : viewer/CLPGUIFrame.java
 * authors    : Guillaume Arnaud
 * created    : ven 30 avr 2004 17:39:38 CEST
 * copyright  : 
 *
 * modifications:
 *
 */

package viewer;

import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import javax.swing.JFrame;

import gui.PavotInternalFrame;

public class CLPGUIFrame extends JFrame implements PavotViewer {
    JDesktopPane desk=new JDesktopPane();
    
    public CLPGUIFrame(){
        super();
        JFrame.setDefaultLookAndFeelDecorated(true);        
        this.setTitle("CLPGUI Viewers");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setSize(1100,800);
        this.setVisible(true);
        this.setContentPane(desk);        
    }
    public void addPavotInternalFrame(PavotInternalFrame pif){
        desk.add(pif);
        desk.setLayer(pif,1);
        pif.getContentPane().setVisible(true);
    }    

    public void refresh(){
        int i;
        JInternalFrame[] jif=desk.getAllFrames();
        for(i=0;i<jif.length;i++){
            jif[i].update(jif[i].getGraphics());
        }
    }

    public int getType(){return 0;}
    public void reshow(){}
}
