/* file name  : viewer/CLPGUIFrame3D.java
 * authors    : Guillaume Arnaud
 * created    : ven 09 avr 2004 14:51:11 CEST
 * copyright  : 
 *
 * modifications:
 *
 */
package viewer;

import java.awt.Frame;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

import java.awt.Graphics;

/** 
 * 
 * 
 * @author Franois Fages, Guillaume Arnaud
 * @version 1.0
 */
public class CLPGUIFrame3D extends Frame implements WindowListener{
	int width=500;
	int height=500;
	CLPGUICanvas3D figure;
	
	public CLPGUIFrame3D(CLPGUICanvas3D c) {
	    setSize(width,height);
	    figure=c;
	    setMenuBar(c.menuBar);

	    figure.resized(width,height-30);
	    add(figure);
	}

	public synchronized void paint(Graphics g) {
	    if (width!=getSize().width || height!=getSize().height) {
		width=getSize().width;
		height=getSize().height;
		figure.resized(width,height-30);
	    }
	}

	public void windowClosing(WindowEvent e)
	{
//	    closing(figure);
	    dispose();
	}
	public void windowClosed(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}
	public void windowActivated(WindowEvent e) {}
	public void windowDeactivated(WindowEvent e) {}
	public void windowOpened(WindowEvent e) {}
    }


